import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

public class Aufgabe1Test {

    private final static int N = 10;
    @Rule
    public Timeout globalTimeout = new Timeout(200);


    @Test
    public void testSearch() throws Exception {
        IntList il = new IntList();
        for (int i = 0; i < N; i++) {
            il.add(i);
        }
        assertThat("Search failed", il.search(1), is(true));
        assertThat("Search returned true for non existent value", il.search(N * 2), is(false));
    }

    @Test
    public void testReverseI() throws Exception {
        IntList il = new IntList();
        for (int i = 0; i < N; i++) {
            il.add(i);
        }
        il.reverseI();
        assertThat("Reverse failed", il.first(), is(N - 1));
        assertThat("Search failed", il.search(N / 2), is(true));
        il.add(N * 2);
        il.reverseI();
        assertThat("Reverse failed", il.first(), is(N * 2));
        assertThat("Search failed", il.search(N / 4), is(true));
    }

    @Test
    public void testReverseR() throws Exception {
        IntList il = new IntList();
        for (int i = 0; i < N; i++) {
            il.add(i);
        }
        il.reverseR();
        assertThat("Reverse failed", il.first(), is(N - 1));
        assertThat("Search failed", il.search(N / 2), is(true));
        il.add(N * 2);
        il.reverseR();
        assertThat("Reverse failed", il.first(), is(N * 2));
        assertThat("Search failed", il.search(N / 4), is(true));
    }

    @Test
    public void testRemove() throws Exception {
        IntList il = new IntList();
        for (int i = 0; i < N; i++) {
            il.add(i);
        }
        assertThat("Remove succeeded", il.remove(3), is(true));
        assertThat("Remove succeeded", il.remove(0), is(true));
        assertThat("Remove succeeded", il.remove(9), is(true));
        assertThat("Remove returned true for non existent value", il.remove(9), is(false));
        assertThat("Remove returned true for non existent value", il.remove(10), is(false));
        assertThat("Remove returned true for non existent value", il.remove(N * 2), is(false));
    }
}