import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import java.util.Arrays;
import java.util.Locale;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.assertTrue;

public class Aufgabe4Test {



    @Rule
    public Timeout globalTimeout = new Timeout(200);

    @Test
    public void testPointCopy() throws Exception {

        Locale.setDefault(Locale.US);

        Point a = new Point(2.5, 1.0);
        Point b = a.copy();

        a.move(-1.5,1.0);

        assertThat("Point#copy failed", b.toString().replaceAll("\\s", ""), is("(2.50,1.00)"));
        assertThat("Point#copy failed", a.toString().replaceAll("\\s", ""), is("(1.00,2.00)"));


    }

    @Test
    public void testPointInterface() throws Exception {

        assertTrue(Arrays.asList(Point.class.getInterfaces()).contains(Copyable.class));

    }

    @Test
    public void testTriangleBasic() throws Exception {

        Locale.setDefault(Locale.US);

        Triangle t = new Triangle(new Point(2.5, 1.0), new Point(-1.0,3.0), new Point(0d,0d));
        assertEquals("test Triangle perimeter", 9.885988937884907, t.perimeter(), 0.00000000001);

        t.move(3.13,-4.2);
        assertEquals("test Triangle perimeter", 9.885988937884907, t.perimeter(), 0.00000000001);
        assertThat("Triangle#move failed", t.toString().replaceAll("\\s",""), is("[(5.63,-3.20),(2.13,-1.20),(3.13,-4.20)]"));

    }

    @Test
    public void testCircleBasic() throws Exception {

        Locale.setDefault(Locale.US);

        Circle c = new Circle(new Point(2.5, 1.0), 1.0);
        assertEquals("test Circle perimeter", 6.283185307179586, c.perimeter(), 0.00000000001);

        c.move(3.13, -4.2);
        assertEquals("test Triangle perimeter", 6.283185307179586, c.perimeter(), 0.00000000001);
        assertThat("Point#copy failed", c.toString().replaceAll("\\s",""), is("[(5.63,-3.20),1.00]"));

    }

    @Test
    public void testTriangleInterface2() throws Exception {

        assertTrue(Arrays.asList(Triangle.class.getInterfaces()).contains(ShapeOnPlane.class));

    }

    @Test
    public void testTriangleCopy() throws Exception {

        Locale.setDefault(Locale.US);

        Triangle t = new Triangle(new Point(2.5, 1.0), new Point(-1.0,3.0), new Point(0d,0d));
        assertEquals("test Triangle perimeter", 9.885988937884907, t.perimeter(), 0.00000000001);

        Triangle tc = t.copy();
        tc.move(3.13,-4.2);
        assertThat("Triangle#move failed", tc.toString().replaceAll("\\s", ""), is("[(5.63,-3.20),(2.13,-1.20),(3.13,-4.20)]"));
        assertThat("Triangle#move failed", t.toString().replaceAll("\\s", ""), is("[(2.50,1.00),(-1.00,3.00),(0.00,0.00)]"));

    }

    @Test
    public void testCircleCopy() throws Exception {

        Locale.setDefault(Locale.US);

        Circle c = new Circle(new Point(2.5, 1.0), 1.0);
        assertEquals("test Circle perimeter", 6.283185307179586, c.perimeter(), 0.00000000001);

        Circle cc = c.copy();
        cc.move(3.13,-4.2);
        assertEquals("test Triangle perimeter", 6.283185307179586, c.perimeter(), 0.00000000001);
        assertThat("Point#copy failed", c.toString().replaceAll("\\s",""), is("[(2.50,1.00),1.00]"));
        assertThat("Point#copy failed", cc.toString().replaceAll("\\s",""), is("[(5.63,-3.20),1.00]"));

    }

    @Test
    public void testCircleInterface2() throws Exception {

        assertTrue(Arrays.asList(Circle.class.getInterfaces()).contains(ShapeOnPlane.class));

    }

}
